package edu.upvehu.gbg.babel;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Babel2 {
    Language[] lenguajes;
    
    Babel2() throws IOException{
        List<Language> ll=new ArrayList<>();
        try (BufferedReader br=new BufferedReader(new FileReader("udhr/languages.txt",Charset.forName("latin1")))){ 
            for( String linea; (linea=br.readLine())!=null; ) {
                String[] campos=linea.split(" ",2);
                ll.add(new Language(campos[0],campos[1],"udhr/txt/"+campos[0]+".txt"));}
            lenguajes=ll.toArray(new Language[0]);}}

    public Language[] findMostSimilars(String langId, int n){
        if (n<=0 || n>=lenguajes.length)
            throw new IllegalArgumentException("El número de lengajes solicitado ("+n+") excede los disponibles.");
        final Language refLang=getLanguage(langId);
        if (refLang==null) throw new IllegalArgumentException("Identificador de lenguaje ("+langId+") desconocido.");

        Arrays.sort(lenguajes, (Language l1, Language l2) -> l1==l2?0: l1==null? 1: l2==null? -1:
                Double.compare(Language.similarity(refLang, l2), Language.similarity(refLang, l1)));
        return Arrays.copyOfRange(lenguajes,1, n);}
      
    public Language getLanguage(String langId){
        if (langId!=null) for (Language lan:lenguajes) if (langId.equals(lan.id)) return lan;
        return null;
    }
}