package edu.upvehu.gbg.babel;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @author bcpbogag
 */
public class Language {
private final Map<Character,Double> frecuencias=new TreeMap<>();
String id, descriptor;
    /**
     * 
     * @param id
     * @param descriptor
     * @param filename 
     * @throws java.io.IOException 
     */
    public Language(String id, String descriptor, String filename) throws IOException {
        this.id=id;
        this.descriptor=descriptor;

    try (BufferedReader br=
            new BufferedReader(
            new FileReader(filename))){  
        int c, n=0;
        while ((c=br.read())!=-1){
          Double d=frecuencias.get((char)c);
          if (d==null)frecuencias.put((char)c,1.0);
          else frecuencias.put((char)c,d+1);
          n++;
        } 
        for (Character ch:frecuencias.keySet())  
            frecuencias.put(ch,frecuencias.get(ch)/n);
    }   
 }

    public String getId() {return id;}
    public String getDescriptor(){return descriptor;}
    
    public static double similarity(Language a, Language b){
      double similarity=0.0;
      for (Character ch:a.frecuencias.keySet())  
        if (b.frecuencias.get(ch)!=null)
          similarity+=Math.min(
                  a.frecuencias.get(ch),
                  b.frecuencias.get(ch));
      return similarity;
    }

    @Override
    public String toString() {
        return "Language{" + "id=" + id + ", descriptor=" + descriptor + '}';
    }
    
}
